import numpy as np


def BiSection(Func, Max, Min, M, Tol, c, GAMMA, cone):
    # check if initial guesses bound root
    if np.sign(Func(Max, M, GAMMA, cone)) == np.sign(Func(Min, M, GAMMA, cone)):
        raise Exception("The scalars a and b do not bound a root")

    # Get Mean Value
    Mean = (Max + Min) / 2

    # Termination Criteria
    if np.abs(Func(Mean, M, GAMMA, cone)) < Tol:
        # stopping condition, report m as root {Based on tolerance}
        return Mean

    elif c > 30:
        # stopping condition, report m as root {Based on max iterations {Values 10 was tested}}
        return Mean


    # Updating Values using BiSection Method
    elif np.sign(Func(Max, M, GAMMA, cone)) == np.sign(Func(Mean, M, GAMMA, cone)):
        c = c + 1
        return BiSection(Func, Mean, Min, M, Tol, c, GAMMA, cone)  # Recursion

    elif np.sign(Func(Min, M, GAMMA, cone)) == np.sign(Func(Mean, M, GAMMA, cone)):
        c = c + 1
        return BiSection(Func, Max, Mean, M, Tol, c, GAMMA, cone)  # Recursion
