def Paraview(x, y, r, phi, U_x, U_y, U_rad, U_phi, Mach):
    # Paraview
    VTK = open("TM.vtk", 'w')
    VTK.write("# vtk DataFile Version 3.0")
    VTK.write("\nvtk output mesh")
    VTK.write("\nASCII")
    VTK.write("\nDATASET STRUCTURED_GRID")
    VTK.write("\nDIMENSIONS" + " " + str(len(r)) + " " + str(len(phi)) + " " + "1")
    VTK.write("\nPOINTS" + " " + str((len(r)) * (len(phi))) + " " + "float")

    for i in range(len(phi)):
        for j in range(len(r)):
            VTK.write("\n" + "% .15f" % x[i, j] + " " + "% .15f" % y[i, j] + " " + "0")

    VTK.write("\nPOINT_DATA " + str((len(r)) * (len(phi))))
    VTK.write("\nVectors Cartesian_Velocities double")
    for i in range(len(phi)):
        for j in range(len(r)):
            VTK.write("\n" + "% .15f" % U_x[i, j] + " " + "% .15f" % U_y[i, j] + " " + "0")

    VTK.write("\nVectors Polar_Velocities double")
    for i in range(len(phi)):
        for j in range(len(r)):
            VTK.write("\n" + "% .15f" % U_rad[i, j] + " " + "% .15f" % U_phi[i, j] + " " + "0")

    VTK.write("\nSCALARS Mach double")
    VTK.write("\nLOOKUP_TABLE default")
    for i in range(len(phi)):
        for j in range(len(r)):
            VTK.write("\n" + "% .15f" % Mach[i, j])

    VTK.close()
